local function Sorted_GetSubcategoryFiltered(slot)
    if Sorted_SubcategoryFrames[Sorted_SelectedFilter].noneSelected then return true end
    if Sorted_SelectedFilter > 3 then
        for i,v in ipairs(Sorted_SubcategoryFrames[Sorted_SelectedFilter].checkButtons) do
            if v.subType == slot.subType then
                return v:GetChecked()
            end
        end
    elseif Sorted_SelectedFilter == 1 then
        local noType1Selected, noType2Selected = true, true
        local type1Match, type2Match = false, false

        if Sorted_SubcategoryFrames[Sorted_SelectedFilter].checkButtons[1]:GetChecked() then
            noType1Selected = false
            if slot.equipLoc == "INVTYPE_WEAPON" or slot.equipLoc == "INVTYPE_WEAPONMAINHAND" or slot.equipLoc == "INVTYPE_WEAPONOFFHAND" then 
                type1Match = true 
            end
        end
        if Sorted_SubcategoryFrames[Sorted_SelectedFilter].checkButtons[2]:GetChecked() then
            noType1Selected = false
            if slot.equipLoc == "INVTYPE_2HWEAPON" then 
                type1Match = true 
            end
        end
        if Sorted_SubcategoryFrames[Sorted_SelectedFilter].checkButtons[3]:GetChecked() then
            noType1Selected = false
            if slot.equipLoc == "INVTYPE_RANGED" or slot.equipLoc == "INVTYPE_THROWN" or slot.equipLoc == "INVTYPE_RANGEDRIGHT" then 
                type1Match = true 
            end
        end
        for i = 4, 17 do
            local v = Sorted_SubcategoryFrames[Sorted_SelectedFilter].checkButtons[i]
            if v:GetChecked() then
                noType2Selected = false
                if slot.subType:match(v.subType) then type2Match = true end
            end
        end
        if noType1Selected then return type2Match end
        if noType2Selected then return type1Match end
        return type1Match and type2Match

    elseif Sorted_SelectedFilter == 2 then
        local noTypeSelected, noLocSelected = true, true
        local typeMatch, locMatch = false, false
        local i = 1
        while i <= 5 do
            local v = Sorted_SubcategoryFrames[Sorted_SelectedFilter].checkButtons[i]
            if v:GetChecked() then
                noTypeSelected = false
                if slot.subType == v.subType then typeMatch = true end
            end
            i = i + 1
        end
        while i <= 13 do
            local v = Sorted_SubcategoryFrames[Sorted_SelectedFilter].checkButtons[i]
            if v:GetChecked() then
                noLocSelected = false
                if slot.equipLoc == v.subType then locMatch = true end
            end
            i = i + 1
        end
        if noTypeSelected then return locMatch end
        if noLocSelected then return typeMatch end
        return locMatch and typeMatch
    else
        for i,v in ipairs(Sorted_SubcategoryFrames[Sorted_SelectedFilter].checkButtons) do
            if v.subType == slot.equipLoc then
                return v:GetChecked()
            end
        end
    end
end

local Sorted_FilterFunctions
if not Sorted_IsClassic() then
    Sorted_FilterFunctions = {
        function(slot) return slot.classID == LE_ITEM_CLASS_WEAPON end,
        function(slot) return slot.classID == LE_ITEM_CLASS_ARMOR and slot.subClassID ~= LE_ITEM_ARMOR_GENERIC and slot.subClassID ~= LE_ITEM_ARMOR_SHIELD and slot.equipLoc ~= "INVTYPE_CLOAK" end,
        function(slot) return slot.classID == LE_ITEM_CLASS_ARMOR and (slot.subClassID == LE_ITEM_ARMOR_GENERIC or slot.subClassID == LE_ITEM_ARMOR_SHIELD or slot.equipLoc == "INVTYPE_CLOAK") end,
        function(slot) return slot.classID == LE_ITEM_CLASS_CONTAINER end,
        function(slot) return slot.classID == LE_ITEM_CLASS_GEM end,
        function(slot) return slot.classID == LE_ITEM_CLASS_ITEM_ENHANCEMENT end,
        function(slot) return slot.classID == LE_ITEM_CLASS_CONSUMABLE end,
        function(slot) return slot.classID == LE_ITEM_CLASS_GLYPH end,
        function(slot) return slot.classID == LE_ITEM_CLASS_TRADEGOODS end,
        function(slot) return slot.classID == LE_ITEM_CLASS_RECIPE end,
        function(slot) return slot.classID == LE_ITEM_CLASS_BATTLEPET end,
        function(slot) return slot.classID == LE_ITEM_CLASS_QUESTITEM end,
        function(slot) return slot.classID == LE_ITEM_CLASS_MISCELLANEOUS end
    }
else
    Sorted_FilterFunctions = {
        function(slot) return slot.classID == LE_ITEM_CLASS_WEAPON end,
        function(slot) return slot.classID == LE_ITEM_CLASS_ARMOR and slot.subClassID ~= LE_ITEM_ARMOR_GENERIC and slot.subClassID < LE_ITEM_ARMOR_SHIELD and slot.equipLoc ~= "INVTYPE_CLOAK" end,
        function(slot) return slot.classID == LE_ITEM_CLASS_ARMOR and (slot.subClassID == LE_ITEM_ARMOR_GENERIC or (slot.subClassID >= LE_ITEM_ARMOR_SHIELD and slot.subClassID <= LE_ITEM_ARMOR_RELIC) or slot.equipLoc == "INVTYPE_CLOAK") end,
        function(slot) return slot.classID == LE_ITEM_CLASS_CONTAINER end,
        function(slot) return slot.classID == LE_ITEM_CLASS_ITEM_ENHANCEMENT end,
        function(slot) return slot.classID == LE_ITEM_CLASS_CONSUMABLE end,
        function(slot) return slot.classID == LE_ITEM_CLASS_TRADEGOODS end,
        function(slot) return slot.classID == LE_ITEM_CLASS_PROJECTILE end,
        function(slot) return slot.classID == LE_ITEM_CLASS_QUIVER end,
        function(slot) return slot.classID == LE_ITEM_CLASS_RECIPE end,
        function(slot) return slot.classID == LE_ITEM_CLASS_REAGENT end,
        function(slot) return slot.classID == LE_ITEM_CLASS_QUESTITEM end,
        function(slot) return slot.classID == LE_ITEM_CLASS_MISCELLANEOUS end
    }
end
local function Sorted_ItemSearchFilter(slot)
    local s1 = slot.name:lower():gsub("%s+", ""):gsub("%p+", "")
    local s2 = SortedFrameSearchBox:GetText():lower():gsub("%s+", ""):gsub("%p+", "")
    -- Search for whole string, ignoring whitespace, punctuation, and case
    if s1:find(s2) then return true end
    -- Search stats
    if Sorted_SearchStatTable(slot.statTable, SortedFrameSearchBox:GetText()) then
        return true
    end
    -- Search for each word separated by spaces
    for s2 in SortedFrameSearchBox:GetText():gmatch("%S+") do
        s2 = string.lower(s2)
        if not s1:find(s2) then return false end
    end
    return true
end
local function Sorted_FilterItem(itemButton)
    local doSearch = (#SortedFrameSearchBox:GetText() > 0 )
    if itemButton.empty then 
        return false
    end

    if Sorted_selectedEquipSet ~= nil then
        local found = false
        for k,v in pairs(Sorted_GetData().equipSets[Sorted_selectedEquipSet].locations) do
            if v.bag == itemButton.bag and v.slot == itemButton.slot then
                found = true
            end
        end
        if not found then return false end
    end

    --[[if _G["SortedFrameFavoritesTab"].value ~= 0 and _G["SortedFrameFavoritesTab"].value ~= Sorted_GetFavorited(itemButton) then
        return false
    else]]if doSearch and (not Sorted_ItemSearchFilter(itemButton)) then
        return false
    elseif Sorted_SelectedFilter == 0 then
        return true
    else
        return Sorted_FilterFunctions[Sorted_SelectedFilter](itemButton) and Sorted_GetSubcategoryFiltered(itemButton)
    end
end

function SortedItemList_FilterItems(self)
    for k, v in pairs(self.itemButtons) do
        if Sorted_FilterItem(v) then
            v.filtered = false
        else
            v.filtered = true
        end
    end
end




function Sorted_DeselectFilterButtons()
    for i,v in ipairs(Sorted_FilterButtons) do
        v.selected = false
        v.selectedTexture:Hide()
    end
end

function SortedFilterButtons_OnLoad(self)
    SortedWeaponsButton.text:SetText(AUCTION_CATEGORY_WEAPONS)
    SortedArmorButton.text:SetText(AUCTION_CATEGORY_ARMOR)
    SortedAccessoriesButton.text:SetText(Sorted_GetLocalised("Accessories"))
    SortedContainersButton.text:SetText(AUCTION_CATEGORY_CONTAINERS)
    SortedGemsButton.text:SetText(AUCTION_CATEGORY_GEMS)
    SortedItemEnhancementsButton.text:SetText(AUCTION_CATEGORY_ITEM_ENHANCEMENT)
    SortedConsumablesButton.text:SetText(AUCTION_CATEGORY_CONSUMABLES)
    SortedGlyphsButton.text:SetText(AUCTION_CATEGORY_GLYPHS)
    SortedTradeGoodsButton.text:SetText(AUCTION_CATEGORY_TRADE_GOODS)
    SortedRecipesButton.text:SetText(AUCTION_CATEGORY_RECIPES)
    SortedBattlePetsButton.text:SetText(AUCTION_CATEGORY_BATTLE_PETS)
    SortedQuestItemsButton.text:SetText(AUCTION_CATEGORY_QUEST_ITEMS)
    SortedMiscellaneousButton.text:SetText(AUCTION_CATEGORY_MISCELLANEOUS)
    SortedProjectileButton.text:SetText(AUCTION_CATEGORY_PROJECTILE)
    SortedQuiverButton.text:SetText(AUCTION_CATEGORY_QUIVER)
    SortedReagentButton.text:SetText(AUCTION_CATEGORY_REAGENT)

    if not Sorted_IsClassic() then
        Sorted_FilterButtons = { SortedWeaponsButton, SortedArmorButton, SortedAccessoriesButton, SortedContainersButton, SortedGemsButton, SortedItemEnhancementsButton, SortedConsumablesButton, SortedGlyphsButton, SortedTradeGoodsButton, SortedRecipesButton, SortedBattlePetsButton, SortedQuestItemsButton, SortedMiscellaneousButton}
    else
        Sorted_FilterButtons = { SortedWeaponsButton, SortedArmorButton, SortedAccessoriesButton, SortedContainersButton, SortedItemEnhancementsButton, SortedConsumablesButton, SortedTradeGoodsButton, SortedProjectileButton, SortedQuiverButton, SortedRecipesButton, SortedReagentButton, SortedQuestItemsButton, SortedMiscellaneousButton}
    end

    Sorted_SelectedFilter = 0
    for i,v in ipairs(Sorted_FilterButtons) do
        v:Show()
        v:SetPoint("TOPLEFT", 6, -6 - v:GetHeight() * (i-1))
        v:SetID(i)
        v:RegisterForClicks("LeftButtonDown", "RightButtonDown")
        v.selectedTexture = v:CreateTexture(v:GetName().."SelectedTexture", "OVERLAY")
        v.selectedTexture:SetAllPoints()
        v.selectedTexture:SetTexture("Interface\\Addons\\Sorted\\Textures\\Buttons")
        v.selectedTexture:SetTexCoord(0, 0.97, 0.375, 0.545)
        v.selectedTexture:Hide()
        v:SetScript("OnClick", function(self, button)
            PlaySound(SOUNDKIT.IG_CHAT_EMOTE_BUTTON  )
            Sorted_DeselectFilterButtons()
            if button == "LeftButton" then
                if Sorted_SelectedFilter == self:GetID() then
                    Sorted_SelectedFilter = 0
                    self.selectedTexture:Hide()
                else
                    Sorted_SelectedFilter = self:GetID()
                    self.selectedTexture:Show()
                end
            else
                Sorted_SelectedFilter = 0
            end
            Sorted_ChangeDisplayedSubcategoryFrame()
            Sorted_FilterItems()
            Sorted_ScrollToTop()
        end)
    end
end



-- SUBCATEGORY FRAME

local SubcategoryCheckButtons
if not Sorted_IsClassic() then
    SubcategoryCheckButtons = {
        {"One-Handed", "Two-Handed", "Ranged", "", "", "Axes", "Maces", "Swords", "Daggers", "Polearms", "Fist Weapons", "Warglaives", "Wands", "Staves", "Bows", "Crossbows", "Guns", "Fishing Poles", "Other"},
        {"Plate", "Mail", "Leather", "Cloth", "Cosmetic", "", "", {"Head", "INVTYPE_HEAD"}, {"Shoulder", "INVTYPE_SHOULDER"}, {"Chest", "INVTYPE_CHEST"}, {"Waist", "INVTYPE_WAIST"}, {"Legs", "INVTYPE_LEGS"}, {"Feet", "INVTYPE_FEET"}, {"Wrist", "INVTYPE_WRIST"}, {"Hands", "INVTYPE_HAND"}},
        {{"Neck", "INVTYPE_NECK"}, {"Cloak", "INVTYPE_CLOAK"}, {"Finger", "INVTYPE_FINGER"}, {"Trinket", "INVTYPE_TRINKET"}, {"Off-hand", "INVTYPE_HOLDABLE"}, {"Shields", "INVTYPE_SHIELD"}, {"Shirt", "INVTYPE_BODY"}, {"Head", "INVTYPE_HEAD"}, {"Tabard", "INVTYPE_TABARD"}},
        {"Bag", {"Herb", "Herb Bag"}, {"Enchanting", "Enchanting Bag"}, {"Engineering", "Engineering Bag"}, {"Gem", "Gem Bag"}, {"Mining", "Mining Bag"}, {"Leatherworking", "Leatherworking Bag"}, {"Inscription", "Inscription Bag"}, "Tackle Box", {"Cooking", "Cooking Bag"}},
        {"Artifact Relic", "Intellect", "Agility", "Strength", "Stamina", "Critical Strike", "Mastery", "Haste", "Versatility", "Other", "Multiple Stats"},
        {"Head", "Neck", "Shoulder", "Cloak", "Chest", "Wrist", "Hands", "Waist", "Legs", "Feet", "Finger", "", {"One-Handed\nWeapons", "Weapon"}, "", {"Two-Handed\nWeapons", "Two-Handed Weapon"}, "", {"Off-hand/\nShield", "Shield/Off-hand"}, "", "Misc"},
        {{"Devices", "Explosives and Devices"}, {"Potions", "Potion"}, {"Elixirs", "Elixir"}, {"Flasks", "Flask"}, "Food & Drink", {"Bandages", "Bandage"}, "Vantus Runes", "Other"},
        {"Warrior", "Paladin", "Hunter", "Rogue", "Priest", "Shaman", "Mage", "Warlock", "Druid", "Death Knight", "Monk", "Demon Hunter"},
        {"Cloth", "Leather", "Metal & Stone", "Cooking", "Herb", "Enchanting", "Inscription", "Jewelcrafting", "Parts", "Elemental", "Other"},
        {"Leatherworking", "Tailoring", "Engineering", "Blacksmithing", "Alchemy", "Enchanting", "Jewelcrafting", "Inscription", "Cooking", "First Aid", "Fishing", "Book"},
        {--[["Humanoid", "Dragonkin", "Flying", "Undead", "Critter", "Magic", "Elemental", "Beast", "Aquatic", "Mechanical"]]},
        {},
        {"Junk", "Reagent", "", {"Companion\nPets", "Companion Pets"}, "", "Holiday", "Other", "Mount", "", {"Mount\nEquipment", "Mount Equipment"}},
    }
else
    SubcategoryCheckButtons = {
        {"One-Handed", "Two-Handed", "Ranged", "", "", "Axes", "Maces", "Swords", "Daggers", "Polearms", "Fist Weapons", "Warglaives", "Wands", "Staves", "Bows", "Crossbows", "Guns", "Fishing Poles", "Other"},
        {"Plate", "Mail", "Leather", "Cloth", "Cosmetic", "", "", {"Head", "INVTYPE_HEAD"}, {"Shoulder", "INVTYPE_SHOULDER"}, {"Chest", "INVTYPE_CHEST"}, {"Waist", "INVTYPE_WAIST"}, {"Legs", "INVTYPE_LEGS"}, {"Feet", "INVTYPE_FEET"}, {"Wrist", "INVTYPE_WRIST"}, {"Hands", "INVTYPE_HAND"}},
        {{"Neck", "INVTYPE_NECK"}, {"Cloak", "INVTYPE_CLOAK"}, {"Finger", "INVTYPE_FINGER"}, {"Trinket", "INVTYPE_TRINKET"}, {"Off-hand", "INVTYPE_HOLDABLE"}, {"Shields", "INVTYPE_SHIELD"}, {"Relics", "INVTYPE_RELIC"}, {"Shirt", "INVTYPE_BODY"}, {"Head", "INVTYPE_HEAD"}, {"Tabard", "INVTYPE_TABARD"}},
        {"Bag", "Soul Bag", {"Herb", "Herb Bag"}, {"Enchanting", "Enchanting Bag"}},
        {"Head", "Neck", "Shoulder", "Cloak", "Chest", "Wrist", "Hands", "Waist", "Legs", "Feet", "Finger", "", {"One-Handed\nWeapons", "Weapon"}, "", {"Two-Handed\nWeapons", "Two-Handed Weapon"}, "", {"Off-hand/\nShield", "Shield/Off-hand"}, "", "Misc"},
        {{"Devices", "Explosives and Devices"}, {"Potions", "Potion"}, {"Elixirs", "Elixir"}, {"Flasks", "Flask"}, "Food & Drink", {"Bandages", "Bandage"}, "Vantus Runes", "Other"},
        {},
        {"Leatherworking", "Tailoring", "Engineering", "Blacksmithing", "Alchemy", "Enchanting", "Cooking", "First Aid", "Fishing", "Book"},
        {},
        {},
        {"Arrow", "Bullet"},
        {"Quiver", "Ammo Pouch"},
        {},
    }
end

local function Sorted_CreateSubcategoryFrame(id, checkBoxesTable)
    local frame = CreateFrame("Frame", "SortedSubcategoryFrame"..id, SortedSubcategoryFrameScrollChild)
    frame:SetPoint("TOPLEFT")
    frame:SetPoint("RIGHT")
    local spaces = 0
    local y = 4
    frame.checkButtons = {}
    frame.noneSelected = true
    for i,v in ipairs(checkBoxesTable) do
        local name = v
        local subType = v
        if type(v) == "table" then name=v[1] subType=v[2] end

        if name=="" then
            spaces = spaces + 1
        else
            local cb = CreateFrame("CheckButton", frame:GetName()..name, frame, "SortedCheckButtonTemplate")
            cb:SetPoint("TOPLEFT", 4, -y - 4 * spaces)
            y = y + spaces * 4
            spaces = 0
            cb.clickable:SetPoint("RIGHT", frame:GetParent(), -4, 0)
            cb:HookScript("OnClick", function(self) 
                Sorted_UpdateSubcategoryFrame(self:GetParent()) 
                Sorted_FilterItems() 
            end)
            cb.text:SetText(name)
            cb.name = name
            cb.subType = subType
            table.insert(frame.checkButtons, cb)
            y = y + cb.clickable:GetHeight()
        end
    end
    frame:SetHeight(y + 4)
    frame:Hide()
    return frame
end

Sorted_SubcategoryFrames = {}
function SortedSubcategoryFrame_OnLoad(self)
    self.scrollBar = CreateFrame("Slider", self:GetName().."ScrollBar", self, "MinimalScrollBarTemplate")
    self.scrollBar.trackBG:Hide()
    self.scrollBar:SetPoint("TOPRIGHT", 1, -18)
    self.scrollBar:SetPoint("BOTTOM", 0, 16)
    self.scrollBar:SetMinMaxValues(1, 1)
    self.scrollBar:SetValueStep(1)
    self.scrollBar.scrollStep = 16
    self.scrollBar:SetValue(0)
    self:SetScrollChild(_G["SortedSubcategoryFrameScrollChild"])

    self:EnableMouseWheel(1)
    self:SetScript("OnMouseWheel", function(self, delta)
        self.scrollBar:SetValue(self.scrollBar:GetValue() - delta * 30)
    end)

    for i,v in ipairs(SubcategoryCheckButtons) do
        table.insert(Sorted_SubcategoryFrames, Sorted_CreateSubcategoryFrame(i, v))
    end
end

function Sorted_ChangeDisplayedSubcategoryFrame()
    for i, v in ipairs(Sorted_SubcategoryFrames) do
        if i == Sorted_SelectedFilter then
            v:Show()
            SortedSubcategoryFrameScrollChild:SetHeight(v:GetHeight())
        else
            v:Hide()
            v.noneSelected = true
            for k,w in pairs(v.checkButtons) do
                w:SetChecked(false)
            end
        end
    end
end

function Sorted_UpdateSubcategoryFrame(frame)
    frame.noneSelected = true
    for i,v in ipairs(frame.checkButtons) do
        if v:GetChecked() then
            frame.noneSelected = false
            return
        end
    end
end